using System.Diagnostics;
using System.Data;
using System.Collections;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System;

namespace Optim_GridSearch1
{
	public delegate double MyFxDelegate(int nNumVars, ref double[] fX, ref double[] fParam);
	public delegate string SayFxDelegate();
	
	public class CGridSearch
	{
		
		
		public double CalcOptim(int nNumVars, ref double[] fXCenter, ref double[] fParam, ref double[] fXLo, ref double[] fXHi, ref int[] nNumDiv, ref double[] fMinDeltaX, double fEpsFx, ref int nIter, MyFxDelegate MyFx)
		{
			double[] fDeltaX;
            double[] fX; 
			double[] fBestX;
            double F, fBestF, fLastBestF;
			int i;
			bool bGoOn, bGoOn2;
			
			fDeltaX = new double[nNumVars];
			fX = new double[nNumVars];
			fBestX = new double[nNumVars];
			
			for (i = 0; i < nNumVars; i++)
			{
				fXCenter[i] = (fXLo[i] + fXHi[i]) / 2;
				fBestX[i] = fXCenter[i];
				fDeltaX[i] = (fXHi[i] - fXLo[i]) / nNumDiv[i];
				fX[i] = fXLo[i];
			}
			
			// calculate and display function value at initial point
            fBestF = MyFx(nNumVars, ref fXCenter, ref fParam);
			if (fBestF > 0)
			{
				fLastBestF = 100 + fBestF;
			}
			else
			{
				fLastBestF = 100 - fBestF;
			}
			
			nIter = 0;
			do
			{
                bGoOn2 = true;
				
				do
				{
					nIter++;
					
                    F = MyFx(nNumVars, ref fX, ref fParam);
					if (F < fBestF)
					{
						fLastBestF = fBestF;
						fBestF = F;
						for (i = 0; i < nNumVars; i++)
						{
							fBestX[i] = fX[i];
						}
					}
					
					//*****************************************************
					// The next For loop implements a programming tricks
					// that simulated nested loops using just one For loop
					//*****************************************************
					// search next grid node
					for (i = 0; i < nNumVars; i++)
					{
						if (fX[i] >= fXHi[i])
						{
							if (i < (nNumVars - 1))
							{
								fX[i] = fXLo[i];
							}
							else
							{
                                bGoOn2 = false;
							}
						}
						else
						{
							fX[i] += fDeltaX[i];
							break;
						}
					}
                } while (bGoOn2);
				
				for (i = 0; i < nNumVars; i++)
				{
					fXCenter[i] = fBestX[i];
					fDeltaX[i] = fDeltaX[i] / nNumDiv[i];
					fXLo[i] = fXCenter[i] - fDeltaX[i] * nNumDiv[i] / 2;
					fXHi[i] = fXCenter[i] + fDeltaX[i] * nNumDiv[i] / 2;
					fX[i] = fXLo[i]; // set initial fX
				}
				
				// fBestF = MyFx(XCenter, N)
				bGoOn = false;
				for (i = 0; i < nNumVars; i++)
				{
					if (fDeltaX[i] > fMinDeltaX[i])
					{
						bGoOn = true;
					}
				}
				
				bGoOn = bGoOn &&(Math.Abs(fBestF - fLastBestF) > fEpsFx);
				
			} while (bGoOn);
			
			return fBestF;
			
		}
	}
	
	
}
